from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=700, b=700)
#robot.reset()
class Vector(object):
    def tolist(self):
        return list(self.input_list)

    def astype(self, input_type):
        if input_type == int:
            return Vector([int(float(x)) for x in self.input_list])
        return Vector([input_type(x) for x in self.input_list])

    def __init__(self, input_list):
        self.input_list = input_list

class DataFrame(object):
    def __len__(self):
        return self.length

    def __getitem__(self, value):
        return Vector(self.dict_input[value])

    def __init__(self, dict_input, length):
        self.dict_input = dict_input
        self.length = length
#Function that reads a csv file correctly without having to import anything (issues with molport). Uses 2 classes, Vector and DataFrame
def read_csv(input_file):
    lines = open(input_file).readlines()
    header = lines[0].rstrip().split(",")
    out_d = {}
    for head in header:
        out_d[head] = []
    for line in lines[1:]:
        spl_line = line.rstrip().split(",")
        for i, head in enumerate(header):
            out_d[head].append(spl_line[i])
    df = DataFrame(out_d, len(lines[1:]))
    return df


#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E3")
tiprack_300_3 = containers.load("tiprack-300ul", "B2")
source_trough12row = containers.load('trough-12row', "E2")
reaction_rack_1 = containers.load("Starlab_96_Square_2mL", "B1")
reaction_rack_2 = containers.load("Starlab_96_Square_2mL", "C1")
reaction_rack_3 = containers.load("Starlab_96_Square_2mL", "D1")
trash = containers.load("point", "B3")

#Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300, tiprack_300_2],
    max_volume=300,
    min_volume=30,
    channels=8,
)

location_solvent = "A5"
volume_solvent = 300
location_aqueous_coupling = "A8"
volume_aqueous_coupling = 300
number_rows_rack_1 = 12
number_rows_rack_2 = 12
number_rows_rack_3 = 8
reaction_racks = [reaction_rack_1,reaction_rack_2,reaction_rack_3]
number_rows_list = [number_rows_rack_1,number_rows_rack_2,number_rows_rack_3]
destination_list = []
for i, v in enumerate (reaction_racks):
    #destination_list.append(x.top() for x in v.rows(0, to=number_rows_list[i]-1))
    intermediate_list = [x.top() for x in v.rows(0, to=number_rows_list[i]-1)]
    destination_list = destination_list + intermediate_list

p300_multi.distribute(volume_aqueous_coupling, source_trough12row.wells(location_aqueous_coupling), destination_list, air_gap=10)

def work_up_acid_or_neutral():
    #for i, v in enumerate (reaction_racks):
    #    intermediate_list = [x.top() for x in v.rows(0, to=number_rows_list[i]-1)]
    #    destination_list = destination_list + intermediate_list
    p300_multi.pick_up_tip()
    p300_multi.aspirate (300, source_trough12row.wells(location_solvent))
    p300_multi.dispense (source_trough12row.wells(location_solvent))
    p300_multi.distribute(volume_solvent, source_trough12row.wells(location_solvent), destination_list, air_gap=10)
    robot.home()

work_up_acid_or_neutral()
#robot.commands()