from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=700, b=700)
#robot.reset()

#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E2")
source_trough4row = containers.load("trough-12row", "C2")
reaction_rack = containers.load("Starlab_96_Square_2mL", "D1")
trash = containers.load("point", "B3")

#Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300, tiprack_300_2],
    max_volume=300,
    min_volume=30,
    channels=8,
)

location_solvent = "A5"
volume_solvent = 600

number_rows = 8

def work_up_acid_or_neutral(reactant):
    p300_multi.pick_up_tip()
    p300_multi.aspirate (300, source_trough4row.wells(location_solvent))
    p300_multi.dispense (source_trough4row.wells(location_solvent))
    p300_multi.distribute(volume_solvent, source_trough4row.wells(location_solvent), [x.top() for x in reaction_rack.rows(0,to=number_rows-1)], air_gap=10)
    robot.home()

work_up_acid_or_neutral(reactant_df)
#robot.commands()