from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=700, b=700)

#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E2")
source_trough12row = containers.load('trough-12row', "E2")
trash = containers.load("point", "B3")
qc_plate_1 = containers.load("96-PCR-flat", "B1")
qc_plate_2 = containers.load("96-PCR-flat", "C1")
qc_plate_3 = containers.load("96-PCR-flat", "D1")

# Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi_no_min',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300,tiprack_300_2],
    max_volume=300,
    min_volume=0,
    channels=8,
)
location_water = "A2"
volume_water = 20

location_solvent = "A5"
volume_solvent = 40
number_rows_plate_1 = 12
number_rows_plate_2 = 12
number_rows_plate_3 = 8

source = source_trough12row.wells(location_solvent)
number_rows_list = [number_rows_plate_1, number_rows_plate_2, number_rows_plate_3]
destination_plate_list =[qc_plate_1, qc_plate_2, qc_plate_3]
destination_list=[]

for index, value in enumerate(destination_plate_list):
    destination_iterative_list = [x.top(-5) for x in value.rows(0, to=number_rows_list[index]-1)]
    destination_list=destination_list + destination_iterative_list

def additional_solvent_to_QC_plate():
    p300_multi.pick_up_tip()
    p300_multi.aspirate(300, source_trough12row.wells(location_solvent))
    p300_multi.dispense(source_trough12row.wells(location_solvent))
    p300_multi.distribute(volume_solvent, source_trough12row.wells(location_solvent), destination_list, air_gap=10)
    p300_multi.distribute(volume_water, source_trough12row.wells(location_water), destination_list, air_gap=10)
    robot.home()

additional_solvent_to_QC_plate()
