from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=700, b=700)

#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E2")
#source_trough12row = containers.load('trough-12row', "E2")
reaction_plate = containers.load("Starlab_96_Square_2mL", "D1")
trash = containers.load("point", "B3")
qc_plate = containers.load("96-PCR-flat", "B1")

# Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi_no_min',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300,tiprack_300_2],
    max_volume=300,
    min_volume=0,
    channels=8,
)

location_solvent = "A5"
volume_solvent = 15
number_rows_plate = 12


source_list = [x.bottom(1) for x in reaction_plate.rows(0, to=number_rows_plate-1)]
destination_list = [x.top(-5) for x in qc_plate.rows(0, to=number_rows_plate-1)]

def transfer_to_QC_plate():
    p300_multi.transfer(volume_solvent, source_list, destination_list, air_gap=10, new_tip="always", blow_out = True)
    robot.home()

transfer_to_QC_plate()
