from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=300, b=700)

#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E2")
reaction_plate = containers.load("Starlab_96_Square_2mL", "D1")
trash = containers.load("point", "B3")
screen_plate = containers.load("Labcyte_384PP", "C1")

# Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi_no_min',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300,tiprack_300_2],
    max_volume=300,
    min_volume=0,
    channels=8,
)

volume_solvent = 30
number_rows_plate = 12


def transfer_to_screen_plate():

    for i in range (0, number_rows_plate):
        destination_list = [screen_plate.rows(i).wells('A', length=8, step=2).bottom(0.5)]
        source_list = [reaction_plate.rows(i).bottom(1)]
        p300_multi.transfer(volume_solvent, source_list, destination_list, blow_out=True, air_gap = 10)
    robot.home()

transfer_to_screen_plate()
