from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=700, b=700)
#robot.reset()

#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E2")
source_trough4row = containers.load("trough-12row", "C2")
reaction_rack = containers.load("Starlab_96_Square_2mL", "D1")
trash = containers.load("point", "B3")

#Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300, tiprack_300_2],
    max_volume=300,
    min_volume=30,
    channels=8,
)

location_solvent = "A5"
volume_solvent = 300
location_aqueous_basic = "A8"
volume_aqueous_basic = 300
location_aqueous_acid = "A2"
volume_aqueous_acid = 300
number_rows = 8


def work_up_acid_or_neutral(reactant):
    for i in range(0, number_rows):
        p300_multi.pick_up_tip()
        p300_multi.mix(6, 100, reaction_rack.rows(i).bottom(7))
        p300_multi.drop_tip()
    robot.home()

work_up_acid_or_neutral(reactant_df)
#robot.commands()