from opentrons import robot, containers, instruments
robot.head_speed(x=21000,  y=21000,  z=4000, a=700, b=700)
#Deck setup
tiprack_300 = containers.load("tiprack-300ul", "D3")
tiprack_300_2 = containers.load("tiprack-300ul", "E3")
source_trough12row = containers.load('trough-12row', "E2")
reaction_rack_1 = containers.load("Starlab_96_Square_2mL", "B1")
reaction_rack_2 = containers.load("Starlab_96_Square_2mL", "C1")
trash = containers.load("point", "B3")

#Pipettes SetUp
p300_multi  = instruments.Pipette(
    name='dlab_300multi',
    axis="a",
    trash_container=trash,
    tip_racks=[tiprack_300, tiprack_300_2],
    max_volume=300,
    min_volume=30,
    channels=8,
)
#shortcut - should be using a csv file for location and volume of solvent / aquous solution to use.
location_solvent = "A5"
volume_solvent = 300
location_aqueous_coupling = "A8"
volume_aqueous_coupling = 300
number_rows_rack_1 = 12
number_rows_rack_2 = 12
reaction_racks = [reaction_rack_1,reaction_rack_2]
number_rows_list = [number_rows_rack_1,number_rows_rack_2]
destination_list = []
for i, v in enumerate (reaction_racks):
    intermediate_list = [x.top() for x in v.rows(0, to=number_rows_list[i]-1)]
    destination_list = destination_list + intermediate_list

p300_multi.distribute(volume_aqueous_coupling, source_trough12row.wells(location_aqueous_coupling), destination_list, air_gap=10)

def work_up_add_solvent_solution():
    p300_multi.pick_up_tip()
    p300_multi.aspirate (300, source_trough12row.wells(location_solvent))
    p300_multi.dispense (source_trough12row.wells(location_solvent))
    p300_multi.distribute(volume_solvent, source_trough12row.wells(location_solvent), destination_list, air_gap=10)
    robot.home()

work_up_add_solvent_solution()
